Bug 1294523 - Review Request: purple-skypeweb - Adds support for Skype to libpurple-based clients
Review Request: purple-skypeweb - Adds support for Skype to libpurple-based c...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Simone Caronni
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-28 13:17 EST by Vitaly Zaitsev
Modified: 2016-07-11 19:19 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-03 08:23:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
negativo17: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Vitaly Zaitsev 2015-12-28 13:17:24 EST
Spec URL: https://raw.githubusercontent.com/xvitaly/purple-skypeweb/master/purple-skypeweb.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/xvitaly/purple-skypeweb/fedora-23-x86_64/00150073-purple-skypeweb/purple-skypeweb-1.0-3.20151225gita173efa.fc23.src.rpm

Description: Adds support for Skype to Pidgin, Adium, Finch and other libpurple 
based messengers.

Fedora Account System Username: xvitaly
Comment 1 Simone Caronni 2016-06-12 09:11:42 EDT
No longer blocking FE-NEEDSPONSOR. I will sponsor Vitaly.

Please remove this lines, they are not needed:

> # generating empty configure script
> echo '#!/bin/bash' > configure
> chmod +x configure

> %configure

It is not mandatory to have a configure script. You can use the following to pass correct CFLAGS when building:

> export CFLAGS="%{optflags}"
> %make_build

A personal request; can you please add these two lines to the "purple-skypeweb" pacakge?

> Provides:       skype4pidgin = %{version}-%{release}
> Obsoletes:      skype4pidgin < %{version}-%{release}

I've been packaging all skype4pidgin plugins for years (including libskypeweb) until now, where skypeweb is mature enough. I would like to make the transition transparent to the official Fedora packages for my users:

http://negativo17.org/skype-and-skype-pidgin-plugin/

This can be removed in a few months.

Please provide again the "Spec URL" and "SRPM URL" lines with the latest changes, fedora-review needs to have them when parsing packages/spec files.
Comment 2 Vitaly Zaitsev 2016-06-12 11:37:52 EDT
> Please remove this lines, they are not needed:

Removed.

> A personal request; can you please add these two lines to the "purple-skypeweb" pacakge?

Added.

> Please provide again the "Spec URL" and "SRPM URL" lines with the latest changes, fedora-review needs to have them when parsing packages/spec files.

SPEC: https://github.com/xvitaly/purple-skypeweb/raw/master/purple-skypeweb.spec

SRPM: https://copr-be.cloud.fedoraproject.org/results/xvitaly/purple-skypeweb/fedora-23-x86_64/00340324-purple-skypeweb/purple-skypeweb-1.1-6.20160510giteb0b500.fc23.src.rpm

rpmlint check result: http://paste.fedoraproject.org/378023/74464314/
Comment 3 Simone Caronni 2016-06-13 09:14:14 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Sources used to build the package match the upstream source, as provided
  in the spec URL.
  Note: Upstream MD5sum check error, diff is in
  /home/slaanesh/Downloads/1294523-purple-skypeweb/diff.txt
  See: http://fedoraproject.org/wiki/Packaging/SourceURL
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: gcc
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v3 or later)", "GPL (v3 or later)",
     "Unknown or generated". 18 files have unknown license. Detailed output
     of licensecheck in /home/slaanesh/Downloads/1294523-purple-
     skypeweb/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/pixmaps/pidgin/emotes/skype
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in pidgin-
     skypeweb , purple-skypeweb-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: purple-skypeweb-1.1-6.20160510giteb0b500.fc23.x86_64.rpm
          pidgin-skypeweb-1.1-6.20160510giteb0b500.fc23.noarch.rpm
          purple-skypeweb-debuginfo-1.1-6.20160510giteb0b500.fc23.x86_64.rpm
          purple-skypeweb-1.1-6.20160510giteb0b500.fc23.src.rpm
purple-skypeweb.x86_64: W: spelling-error %description -l en_US libpurple -> lib purple, lib-purple, purple
pidgin-skypeweb.noarch: W: spelling-error %description -l en_US inplemented -> implemented, supplemented, complemented
pidgin-skypeweb.noarch: W: spelling-error %description -l en_US libskypeweb 
pidgin-skypeweb.noarch: W: no-documentation
purple-skypeweb.src: W: spelling-error %description -l en_US libpurple -> lib purple, lib-purple, purple
4 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (debuginfo)
-------------------
Checking: purple-skypeweb-debuginfo-1.1-6.20160510giteb0b500.fc23.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
pidgin-skypeweb.noarch: W: spelling-error %description -l en_US inplemented -> implemented, supplemented, complemented
pidgin-skypeweb.noarch: W: spelling-error %description -l en_US libskypeweb 
pidgin-skypeweb.noarch: W: no-documentation
purple-skypeweb.x86_64: W: spelling-error %description -l en_US libpurple -> lib purple, lib-purple, purple
3 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
purple-skypeweb-debuginfo (rpmlib, GLIBC filtered):

pidgin-skypeweb (rpmlib, GLIBC filtered):
    pidgin
    purple-skypeweb

purple-skypeweb (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libjson-glib-1.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    libpurple.so.0()(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
purple-skypeweb-debuginfo:
    purple-skypeweb-debuginfo
    purple-skypeweb-debuginfo(x86-64)

pidgin-skypeweb:
    pidgin-skypeweb

purple-skypeweb:
    libskypeweb.so()(64bit)
    purple-skypeweb
    purple-skypeweb(x86-64)
    skype4pidgin



Unversioned so-files
--------------------
purple-skypeweb: /usr/lib64/purple-2/libskypeweb.so

Source checksums
----------------
https://github.com/EionRobb/skype4pidgin/archive/eb0b5000c56c9c264375ab2334c926c9715ee3d0.tar.gz#/skype4pidgin-eb0b500.tar.gz :
  CHECKSUM(SHA256) this package     : fa04af47d80c9ac82ede905b6a103dcbf48e0e707c5b5d7111f00e0897a49705
  CHECKSUM(SHA256) upstream package : d96bccd0e2c56acf347ceac7b89d05cea2993505599b3fe915789a23a116e604
diff -r also reports differences


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1294523
Buildroot used: fedora-23-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 4 Simone Caronni 2016-06-13 09:22:35 EDT
> - Sources used to build the package match the upstream source, as provided
>   in the spec URL.
>   Note: Upstream MD5sum check error, diff is in
>   /home/slaanesh/Downloads/1294523-purple-skypeweb/diff.txt
>   See: http://fedoraproject.org/wiki/Packaging/SourceURL

This is ok, the tarball is renamed according to packaging guidelines.

> - All build dependencies are listed in BuildRequires, except for any that
>   are listed in the exceptions section of Packaging Guidelines.
>   Note: These BR are not needed: gcc
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

This is ok as no longer true, BR can now be excplicitly required.

> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "*No copyright* GPL (v3 or later)", "GPL (v3 or later)",
>      "Unknown or generated". 18 files have unknown license. Detailed output
>      of licensecheck in /home/slaanesh/Downloads/1294523-purple-
>      skypeweb/licensecheck.txt

This is ok, but please ask upstream to add all proper headers. Otherwise, since this is a subset of the whole (obsolete) skype4pidgin tarball, just package in the tarball only the required folders. You can use this guideline if you want to proceed that way:

http://fedoraproject.org/wiki/Packaging:SourceURL#When_Upstream_uses_Prohibited_Code

> [!]: Package must own all directories that it creates.
>      Note: Directories without known owners:
>      /usr/share/pixmaps/pidgin/emotes/skype

Just remove the "theme" at the end of this line in the files section:

%{_datadir}/pixmaps/pidgin/emotes/skype/theme

> [!]: Patches link to upstream bugs/comments/lists or are otherwise
>      justified.

Please add some notes to the patch. I don't see why the code in the patch should be removed, if there is an explanation for it, please add it to the SPEC file.

Also, please remove the "%if 0%{?fedora}/%endif" part around Patch0. If I'm downloading the source rpm for some rebuild on (whatever) unreleased distribution (let's say a beta RHEL that has everything included) I won't get the patch file from the Koji build, and I would need to download it from the SCM.

It's perfectly acceptable to have patches shipped and just applied conditionally.

> pidgin-skypeweb.noarch: W: spelling-error %description -l en_US inplemented -> implemented, supplemented, complemented

There's a typo in the comment, 's/inplemented/implemented/g'.
Comment 5 Simone Caronni 2016-06-13 09:23:59 EDT
Package is almost good to go, just fix the typo, directory ownership and the patch thing!

Many thanks for adding the skype4pidgin Obsoletes/Provides.
Comment 6 Vitaly Zaitsev 2016-06-13 18:22:46 EDT
> This is ok, but please ask upstream to add all proper headers. Otherwise, since this is a subset of the whole (obsolete) skype4pidgin tarball, just package in the tarball only the required folders. You can use this guideline if you want to proceed that way:

Yes, I'll add script which will repackage tarball.

> Just remove the "theme" at the end of this line in the files section:

Done.

> Please add some notes to the patch. I don't see why the code in the patch should be removed, if there is an explanation for it, please add it to the SPEC file.

This patch is no longer needed.

> There's a typo in the comment, 's/inplemented/implemented/g'.

Fixed. Thanks.
Comment 8 Simone Caronni 2016-06-15 09:51:54 EDT
Hi Vitaly, this does not really work, as the various tools will complain that the tarball specified in the URL of the spec file does not match the checksum of the tarball that is actually shipped in the src.rpm; prompting you to do something because the tarball has been tampered with.

I would personally do something like that:

1- Change source0 to read the following:

Source0: %{name}-%{shortcommit0}.tar.xz

2- Adjust your script to do the checkout and repack as follows (this is an example):

#!/bin/sh

TARBALL=purple-skypeweb

git clone -q https://github.com/EionRobb/skype4pidgin.git
cd skype4pidgin
COMMIT=$(git log -n 1 --format=%H)
SHORTCOMMIT=${COMMIT:0:7}
mv skypeweb ../$TARBALL-$COMMIT
cd ..

tar -cJf $TARBALL-$SHORTCOMMIT.tar.xz $TARBALL-$COMMIT
rm -fr skype4pidgin

echo commit0 $COMMIT
echo Source0 $TARBALL-$SHORTCOMMIT.tar.xz

When running, you will get this output, so you can paste the commit id directly in the spec file:

$ ./purple-skypeweb-tarball.sh 
commit0 eb0b5000c56c9c264375ab2334c926c9715ee3d0
Source0 purple-skypeweb-eb0b500.tar.xz

This way, the Source0 is only checked locally and you won't have hash mismatches, you have a consistent SPEC file with commits etc., source is reduced and you provide the tarball script.
Comment 9 Simone Caronni 2016-06-15 09:54:36 EDT
Then updating the package would basically be:

1- Run tarball script
2- Replace the id at the top of the SPEC file
3- Bump the spec file (rpmdev-bumpspec will take care of release, changelog, etc:

rpmdev-bumpspec -c "Update to latest sources." purple-skypeweb.spec

4- Upload new sources

fedpkg new-sources purple-skypeweb-<shortcommit>.tar.xz

5- Commit all, push and build

git commit -a -m "Update to latest sources", git push, fedpkg build
Comment 10 Simone Caronni 2016-06-15 10:00:21 EDT
Ah, the %autosetup line in the SPEC file would need to be changed as well with the example above (comment #8):

%autosetup -n %{name}-%{commit0}
Comment 12 Simone Caronni 2016-06-16 06:37:37 EDT
Package approved! Thanks for the quick interactions.

Please proceed into asking for SCM access as depicted in the guidelines (point no. 8):

http://fedoraproject.org/wiki/Package_Review_Process#Contributor

If you need any assistance on anything, just drop me an email.
Comment 13 Gwyn Ciesla 2016-06-16 09:12:42 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/purple-skypeweb
Comment 14 Gwyn Ciesla 2016-06-16 09:16:34 EDT
Package request has been denied with the reason: Re-requesting.
Comment 15 Gwyn Ciesla 2016-06-16 09:18:45 EDT
Package request has been denied with the reason: Re-requesting.
Comment 16 Gwyn Ciesla 2016-06-16 09:19:51 EDT
Package request has been denied with the reason: Re-requesting.
Comment 17 Fedora Update System 2016-06-17 09:10:57 EDT
purple-skypeweb-1.1-9.20160510giteb0b500.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-984c3b0430
Comment 18 Fedora Update System 2016-06-17 09:12:24 EDT
purple-skypeweb-1.1-9.20160510giteb0b500.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-79e860a25c
Comment 19 Fedora Update System 2016-06-18 01:24:06 EDT
purple-skypeweb-1.1-9.20160510giteb0b500.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-79e860a25c
Comment 20 Fedora Update System 2016-06-18 12:25:54 EDT
purple-skypeweb-1.1-9.20160510giteb0b500.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-984c3b0430
Comment 21 Fedora Update System 2016-06-25 08:47:02 EDT
purple-skypeweb-1.1-9.20160510giteb0b500.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-79e860a25c
Comment 22 Fedora Update System 2016-06-25 09:06:40 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-e482d5c765
Comment 23 Fedora Update System 2016-06-25 09:07:49 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-76f227d32a
Comment 24 Fedora Update System 2016-06-25 09:08:34 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-244b53880a
Comment 25 Fedora Update System 2016-06-25 20:21:01 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-244b53880a
Comment 26 Fedora Update System 2016-06-25 20:26:29 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-76f227d32a
Comment 27 Fedora Update System 2016-06-26 02:21:33 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-e482d5c765
Comment 28 Fedora Update System 2016-07-03 08:23:24 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 29 Fedora Update System 2016-07-05 04:25:18 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 30 Fedora Update System 2016-07-11 19:19:43 EDT
purple-skypeweb-1.1-11.20160620git72f0b00.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.